org.codehaus.groovy.runtime.metaclass

## Class ConcurrentReaderHashMap.HashIterator

- java.lang.Object
- - org.codehaus.groovy.runtime.metaclass.ConcurrentReaderHashMap.HashIterator

- All Implemented Interfaces:
    java.util.Enumeration, java.util.Iterator
  Direct Known Subclasses:
    ConcurrentReaderHashMap.KeyIterator, ConcurrentReaderHashMap.ValueIterator
  Enclosing class:
    ConcurrentReaderHashMap

      protected class ConcurrentReaderHashMap.HashIterator
      extends java.lang.Object
      implements java.util.Iterator, java.util.Enumeration

- - ### Field Summary

    Fields
    Modifier and Type | Field and Description
    --- | ---
    `protected java.lang.Object` | `currentKey`
    `protected java.lang.Object` | `currentValue`
    `protected ConcurrentReaderHashMap.Entry` | `entry`
    `protected int` | `index`
    `protected ConcurrentReaderHashMap.Entry` | `lastReturned`
    `protected ConcurrentReaderHashMap.Entry[]` | `tab`

  - ### Constructor Summary

    Constructors
    Modifier | Constructor and Description
    --- | ---
    `protected` | `HashIterator()`

  - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `boolean` | `hasMoreElements()`
    `boolean` | `hasNext()`
    `java.lang.Object` | `next()`
    `java.lang.Object` | `nextElement()`
    `void` | `remove()`
    `protected java.lang.Object` | `returnValueOfNext()`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

    - ### Methods inherited from interface java.util.Iterator

      `forEachRemaining`

- - ### Field Detail

    - #### tab

          protected final ConcurrentReaderHashMap.Entry[] tab

    - #### index

          protected int index

    - #### entry

          protected ConcurrentReaderHashMap.Entry entry

    - #### currentKey

          protected java.lang.Object currentKey

    - #### currentValue

          protected java.lang.Object currentValue

    - #### lastReturned

          protected ConcurrentReaderHashMap.Entry lastReturned

  - ### Constructor Detail

    - #### HashIterator

          protected HashIterator()

  - ### Method Detail

    - #### hasMoreElements

          public boolean hasMoreElements()

      Specified by:
        `hasMoreElements` in interface `java.util.Enumeration`

    - #### nextElement

          public java.lang.Object nextElement()

      Specified by:
        `nextElement` in interface `java.util.Enumeration`

    - #### hasNext

          public boolean hasNext()

      Specified by:
        `hasNext` in interface `java.util.Iterator`

    - #### returnValueOfNext

          protected java.lang.Object returnValueOfNext()

    - #### next

          public java.lang.Object next()

      Specified by:
        `next` in interface `java.util.Iterator`

    - #### remove

          public void remove()

      Specified by:
        `remove` in interface `java.util.Iterator`